/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.

 * < wxTutorial! Tutorial para el aprendizaje de las bibliotecas wxWidgets.>
 * Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#ifndef _APP_
#define _APP_

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include <wx/wx.h>

/**
 * @brief Clase padre de la aplicación la cual
 * tiene la funcionalidad de iniciarla.
 * 
 * @author Rosa María Durante Lerate
 * @note Parte del proyecto wxTutorial!
 */
class App : public wxApp {
 public:

  /**
   * @brief Inicia la aplicación. Es la primera 
   * función que se llama cuando el usuario quiere 
   * abrir la aplicación.
   * @return Retorna un valor (verdadero o falso) 
   * dependiendo de si la aplicación se ha iniciado
   * correctamente o no.
   */
  virtual bool OnInit();
};

DECLARE_APP(App)

#endif
