
/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

< wxTutorial! Tutorial para el aprendizaje de las bibliotecas wxWidgets.>
Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#include "dshow.h"
#include "path.h"

enum ids_cap {
  ID_CheckImage,
  ID_ChangeChapter,
  ID_ChangeExample,
};

BEGIN_EVENT_TABLE(DialogShowChapter, wxDialog)
EVT_COMBOBOX(ID_ChangeChapter, DialogShowChapter::OnChangeChapter)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(DialogShowExample, wxDialog)
EVT_COMBOBOX(ID_ChangeExample, DialogShowExample::OnChangeChapter)
END_EVENT_TABLE()

DialogShowChapter::DialogShowChapter(wxWindow* parent,  wxWindowID id, const wxString& title):
wxDialog(parent, id, title, wxDefaultPosition, wxSize(350,220)) // 220
{
  // Centramos la ventana de diálogo en la pantalla.
  Centre();
  
  cancel = new wxButton(this, wxID_CANCEL, wxString::FromUTF8("Cancelar"), wxPoint(130, 160));
  ok = new wxButton(this, wxID_OK, wxString::FromUTF8("Aplicar"), wxPoint(250, 160));
  
  labelchapter = new wxStaticText(this, wxID_ANY, wxString::FromUTF8("Selecciona el artículo a visualizar..."),
				  wxPoint(30,20), wxSize(310,30));
  
  wxString aux[7] = {wxString::FromUTF8("1. Introducción."),
		     wxString::FromUTF8("2. Conceptos Básicos."),
		     wxString::FromUTF8("3. Componentes Básicos."),
		     wxString::FromUTF8("4. Componentes de Imagen."),
		     wxString::FromUTF8("5. Componentes de Elección."),
		     wxString::FromUTF8("6. Componentes Contenedores."),
		     wxString::FromUTF8("7. Componentes de Diálogo.")};
  
  chapter = new wxComboBox(this, ID_ChangeChapter, wxString::FromUTF8("Selecciona un capítulo.."), wxPoint(20,50),
			   wxSize(310, 30),7, aux, wxCB_DROPDOWN | wxCB_READONLY );
  
  subchapter = new wxComboBox(this, wxID_ANY, wxString::FromUTF8("Selecciona un subcapítulo..."),
			      wxPoint(20,100), wxSize(310,30));  
  
}

void DialogShowChapter::OnChangeChapter(wxCommandEvent& event)
{
  subchapter->Clear();
  subchapter->SetValue(wxString::FromUTF8("Selecciona un subcapítulo..."));
  
  switch(chapter->GetCurrentSelection()){
  case 0: subchapter->Insert(wxString::FromUTF8("¿Qué son las bibliotecas gráficas?."),0);
    subchapter->Insert(wxString::FromUTF8("¿Cómo programar en wxWidgets?."),1);
    subchapter->Insert(wxString::FromUTF8("El entorno wxDevC++."),2);
    subchapter->Insert(wxString::FromUTF8("Otras bibliotecas gráficas."),3);
    break;
  case 1: subchapter->Insert(wxString::FromUTF8("Componentes."),0);
    subchapter->Insert(wxString::FromUTF8("Tipos de datos."),1);
    subchapter->Insert(wxString::FromUTF8("Eventos."),2);
    subchapter->Insert(wxString::FromUTF8("Primer Ejemplo."),3);
    break;
  case 2: subchapter->Insert(wxString::FromUTF8("wxApp, wxFrame, wxButton."),0);
    subchapter->Insert(wxString::FromUTF8("wxStaticText, wxEdit."),1);
    subchapter->Insert(wxString::FromUTF8("wxMenu."),2);
    break;
  case 3: subchapter->Insert(wxString::FromUTF8("Imagen"),0);
    break;
  case 4: subchapter->Insert(wxString::FromUTF8("wxChoice, wxComboBox, wxListBox."),0);
    subchapter->Insert(wxString::FromUTF8("wxCheckBox, wxRadioBox."),1);
    break;
  case 5: subchapter->Insert(wxString::FromUTF8("wxPanel."),0);
    subchapter->Insert(wxString::FromUTF8("wxNotebook."),1);
    subchapter->Insert(wxString::FromUTF8("wxHtmlWindow."),2);
    break;
  case 6: subchapter->Insert(wxString::FromUTF8("wxDialog."),0);
    subchapter->Insert(wxString::FromUTF8("Diálogos de entrada de datos."),1); 
    subchapter->Insert(wxString::FromUTF8("Diálogos de salida de datos."),2);
    subchapter->Insert(wxString::FromUTF8("Diálogos de ficheros."),3);
    break;
  }
}

size_t DialogShowChapter::Process()
{
  size_t pag=0;
  
  switch(chapter->GetCurrentSelection()) {
  case 0: {
    switch(subchapter->GetCurrentSelection()) {
    case 0: pag=1; break;
    case 1: pag=2; break;
    case 2: pag=3; break;
    case 3: pag=4; break;
    }  
  }
    break;
    
  case 1: {
    switch(subchapter->GetCurrentSelection()){
    case 0: pag=5; break;
    case 1: pag=6; break;
    case 2: pag=7; break;
    case 3: pag=8; break;
    }
  }
    break;
    
  case 2: {  
    switch(subchapter->GetCurrentSelection()){
    case 0: pag=9; break;
    case 1: pag=10; break;
    case 2: pag=11; break;
    }
  }
    break;
    
  case 3: pag=12; break;
    break;

  case 4: {
    switch(subchapter->GetCurrentSelection()){
    case 0: pag=13; break;
    case 1: pag=14; break;
    }
  }
    break;

  case 5: {
    switch(subchapter->GetCurrentSelection()){
    case 0: pag=15; break;
    case 1: pag=16; break;
    case 2: pag=17; break;
    }
  }
    break;

  case 6:{
    switch(subchapter->GetCurrentSelection()){
    case 0: pag=18; break;
    case 1: pag=19; break;
    case 2: pag=20; break;
    case 3: pag=21; break;
    }
  }
    break;
  }
  return pag;
}

DialogShowExample::DialogShowExample(wxWindow* parent,  wxWindowID id, const wxString& title):
  wxDialog(parent, id, title, wxDefaultPosition, wxSize(350,220)) // 220
{
  // Centramos la ventana de diálogo en la pantalla.
  Centre();
  
  cancel = new wxButton(this, wxID_CANCEL, wxString::FromUTF8("Cancelar"), wxPoint(130, 160));
  ok = new wxButton(this, wxID_OK, wxString::FromUTF8("Aplicar"), wxPoint(250, 160));

  labelchapter = new wxStaticText(this, wxID_ANY, wxString::FromUTF8("Selecciona el ejemplo a visualizar..."),
				  wxPoint(30,20), wxSize(310,30));
  
  wxString aux[4] = {wxString::FromUTF8("Hola Mundo."),
		     wxString::FromUTF8("Ejemplo Capítulo 03 y 04."),
		     wxString::FromUTF8("Ejemplo Capítulo 05."),
		     wxString::FromUTF8("wxTutorial.")};

  chapter = new wxComboBox(this, ID_ChangeExample, wxString::FromUTF8("Selecciona un capítulo.."), wxPoint(20,50),
			   wxSize(310, 30),4, aux, wxCB_DROPDOWN | wxCB_READONLY );
  subchapter = new wxListBox(this, wxID_ANY , wxPoint(20, 85), wxSize(310,60));

  image = new wxCheckBox(this, ID_CheckImage,  wxString::FromUTF8("Imágenes."), 
			 wxPoint(20,160));
  
}

void DialogShowExample::OnChangeChapter(wxCommandEvent& event)
{
  subchapter->Clear();
  switch(chapter->GetCurrentSelection()){
  case 0: {
    subchapter->Insert(wxString::FromUTF8("holamundo.h"),0);
    subchapter->Insert(wxString::FromUTF8("holamundo.cpp"),1);
  }
    break;
  case 1: {
    subchapter->Insert(wxString::FromUTF8("ejemploCap03.h"),0);
    subchapter->Insert(wxString::FromUTF8("ejemploCap03.cpp"),1);
  }
    break;
  case 2: {
    subchapter->Insert(wxString::FromUTF8("ejemploCap05.h"),0);
    subchapter->Insert(wxString::FromUTF8("ejemploCap05.cpp"),1);
    //...
  }
    break;
  case 3: {
    subchapter->Insert(wxString::FromUTF8("app.h"),0);
    subchapter->Insert(wxString::FromUTF8("app.cpp"),1);
    subchapter->Insert(wxString::FromUTF8("path.h"),2);
    subchapter->Insert(wxString::FromUTF8("path.cpp"),3);
    subchapter->Insert(wxString::FromUTF8("form.h"),4);
    subchapter->Insert(wxString::FromUTF8("form.cpp"),5);
    subchapter->Insert(wxString::FromUTF8("viewer.h"),6);
    subchapter->Insert(wxString::FromUTF8("viewer.cpp"),7);
    subchapter->Insert(wxString::FromUTF8("nav.h"),8);
    subchapter->Insert(wxString::FromUTF8("nav.cpp"),9);
    subchapter->Insert(wxString::FromUTF8("dexp.h"),10);
    subchapter->Insert(wxString::FromUTF8("dexp.cpp"),11);
    subchapter->Insert(wxString::FromUTF8("dshow.h"),12);
    subchapter->Insert(wxString::FromUTF8("dshow.cpp"),13);
    subchapter->Insert(wxString::FromUTF8("ddl.h"),14);
    subchapter->Insert(wxString::FromUTF8("ddl.cpp"),15);
    subchapter->Insert(wxString::FromUTF8("dimag.h"),16);
    subchapter->Insert(wxString::FromUTF8("dimag.cpp"),17);
  }
    break;
  }
}

int DialogShowExample::Process()
{
  size_t pag=-1;

  switch(chapter->GetCurrentSelection()){
  case 0: {
    if(subchapter->IsSelected(0))
      pag = 0;
    if(subchapter->IsSelected(1))
      pag = 1;
  }
    break;
  case 1: {
    if(subchapter->IsSelected(0))
      pag = 2;
    if(subchapter->IsSelected(1))
      pag = 3;
  }
    break;
  case 2: {
    if(subchapter->IsSelected(0))
      pag = 4;
    if(subchapter->IsSelected(1))
      pag = 5;
  }
    break;
  case 3: {
    if(subchapter->IsSelected(0))
      pag = 6;
    if(subchapter->IsSelected(1))
      pag = 7;
    if(subchapter->IsSelected(2))
      pag = 8;
    if(subchapter->IsSelected(3))
      pag = 9;
    if(subchapter->IsSelected(4))
      pag = 10;
    if(subchapter->IsSelected(5))
      pag = 11;
    if(subchapter->IsSelected(6))
      pag = 12;
    if(subchapter->IsSelected(7))
      pag = 13;
    if(subchapter->IsSelected(8))
      pag = 14;
    if(subchapter->IsSelected(9))
      pag = 15;
    if(subchapter->IsSelected(10))
      pag = 16;
    if(subchapter->IsSelected(11))
      pag = 17;
    if(subchapter->IsSelected(12))
      pag = 18;
    if(subchapter->IsSelected(13))
      pag  =19;
    if(subchapter->IsSelected(14))
      pag = 20;
    if(subchapter->IsSelected(15))
      pag = 21;
    if(subchapter->IsSelected(16))
      pag = 22;
    if(subchapter->IsSelected(17))
      pag = 23;
  }
    break;
  }
  return pag;
}

int DialogShowExample::Example()
{
  if(image->IsChecked())
    return chapter->GetCurrentSelection();
  else
    return -1;
}
